Subject: Re: bug#19238: Fully fix du circular warning on bind mounts

From: Pádraig Brady <[email-masked]>
Date: Mon, 01 Dec 2014 12:49:59 +0000

On 01/12/14 08:54, Boris Ranto wrote:
> The du circular warning can still be hit even though a file system is in
> good condition. All we need to do is to get the message is to begin
> traversing the file system between the bind mount source and bind mount
> target directories, i.e this short script reproduces the problem:
> 
> # mkdir -p a/b/c
> # mount -o bind a a/b/c
> # du a/b
> 
> The problem is that in this case, the first directory that is detected
> by fts as a duplicate directory is directory a/b/c/b which is not a
> mount point.
> 
> The solution is to traverse the structure all the way to a/b (excluding
> a/b) which is detected as the base of the cycle and look up all these
> directories in the mount table.
> 
> I'm attaching the patch that fixed this problem for me.

Very nice. Thanks for the test!
I'll add a NEWS entry and push later.

thanks!
Pádraig